'****************************************
'Declare variables
'****************************************
Dim strmsiFile, strTransformFile, Appdata, PackageName 
Const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002


'****************************************
' Set Objects
'****************************************

Set objShell      = CreateObject("WScript.Shell")
set objFSO        = CreateObject("scripting.FileSystemObject") 
Set Installer     =	CreateObject("WindowsInstaller.installer")

'****************************************
' Retrieve Test Package Settings
'****************************************
strMsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSiFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile") 
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\Currentversion\Explorer\Shell Folders\Local Appdata")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")
Website           = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\Website")

set outfile       =	objFSO.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for append
Set Database      =	Installer.OpenDatabase(strMsiFile, 0)


If Not strTransformFile ="" Then 
	Database.ApplyTransform strTransformFile, 0
End if

'****************************************
'Script
'****************************************
Name			        ="" 'Friendly name of the script
ScriptPurpose	    = "Ensure that the Rootdrive property is set"
ScriptName		    ="" 'Actual name of the script run
ScriptResult	    =""

Set streamobj = Database.SummaryInformation(0) '0 = read only 'WScript.Echo streamobj.Property(9)
propertylist ="0? =" &streamobj.Property(0) & vbNewline _
&	"?1 =" &streamobj.Property(1) & vbNewline _
&	"Subject =" &streamobj.Property(2) & vbNewline _
&	"Title = " & streamobj.Property(3) & vbNewline _
&	"Author = " & streamobj.Property(4) & vbNewline _
&	"Keywords = " & streamobj.Property(5) & vbNewline _
&	"Comments = " & streamobj.Property(6) & vbNewline _
&	"Platform and Language = " &streamobj.Property(7) & vbNewline _
&	"Hidden = " &streamobj.Property(8) & vbNewline _
&	"PackageCode = " &streamobj.Property(9) & vbNewline _ 
& "?10 =" &streamobj.Property(10) & vbNewline _
&	"Date Time Last Altered = " &streamobj.Property(11) & vbNewline _
&	"?12 =" &streamobj.Property(12) & vbNewline _
&	"?13 =" &streamobj.Property(13) & vbNewline _
&	"Schema = " &streamobj.Property(14) & vbNewline _
&	"wordcount = " &streamobj.Property(15) & vbNewline _
&	"? = " &streamobj.Property(16) & vbNewline _
&	"? = " &streamobj.Property(17) & vbNewline _
&	"Hidden Created By Field = " &streamobj.Property(18) & vbNewline _
&	"?19 = " &streamobj.Property(19) & vbNewline _

PackageCode = streamobj.Property(9)

'****************************************
'Results
'****************************************
outfile.writeline("<my:PackageCode>" & PackageCode &"</my:PackageCode>") 
outfile.close


'****************************************
'Cleanup
'****************************************

'Results
Cleanup

'****************************************
'Functions and Subs
'****************************************
sub Results
	outfile.writeline( "<my:Test>")
	outfile.writeline( "<my:Name>" &Name &"</my:Name>") 
	outfile.writeline( "<my:ScriptName>" &ScriptName &"</my:ScriptName>")
	outfile.writeline( "<my:ScriptResult>" &ScriptResult &"</my:ScriptResult>") 
	outfile.writeline( "<my:ScriptPurpose>" &ScriptPurpose &"</my:ScriptPurpose>")
	outfile.writeline("<my:HelpURL>http://www.laurierhodes.info/sites/default/files/MSICheck/" &ScriptName &".html</my:HelpURL>") 	
	outfile.writeline( "<my:Message>" &Message &"</my:Message>") 
	outfile.writeline( "<my:ResultComments></my:ResultComments>") 
	outfile.writeline( "</my:Test>")
	outfile.close
end sub

function MakeSafe(tempstring)
	tempstring = Replace (tempstring,">","&gt;") 
	tempstring = Replace (tempstring,"<","&lt;") 
	tempstring = Replace (tempstring,"&","&amp;") 
	tempstring = Replace (tempstring,"'","&apos;") 
	tempstring = Replace (tempstring,chr(34),"&quot;") 
	MakeSafe = tempstring
end function

sub Cleanup
	'Set Objects to Nothing 
	Set objShell =	Nothing
	Set wshNetwork 	= Nothing
	Set Installer 	= Nothing
	Set View 		= Nothing
	set Record 		= Nothing
End Sub
