'****************************************
'Declare variables
'****************************************
Dim strmsiFile, strTransformFile, Appdata, PackageName 
Const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002


'****************************************
' Set Objects
'****************************************

Set objShell      = CreateObject("WScript.Shell")
set objFSO        = CreateObject("scripting.FileSystemObject") 
Set Installer     =	CreateObject("WindowsInstaller.installer")

'****************************************
' Retrieve Test Package Settings
'****************************************
strMsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSiFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile") 
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\Currentversion\Explorer\Shell Folders\Local Appdata")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")
Website           = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\Website")

set outfile       =	objFSO.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for append
Set Database      =	Installer.OpenDatabase(strMsiFile, 0)


If Not strTransformFile ="" Then 
	Database.ApplyTransform strTransformFile, 0
End if

'****************************************
'Script
'****************************************
Name		        = "Custom Actions HardCoding" 'Friendly name of the script
ScriptPurpose   = "To ensure that varibles are used instead of hardcoding locations" 
ScriptName	    = "16_CustomActionHardCoding" 'Actual name of the script run 
ScriptResult    = ""

'We have to be sure that there is a Registry table within the MSI. 
if DoesTableExist("CustomAction") = False then
	message = "This database does not contain a Registry Table"
	ScriptResult = "Pass"
	Results 
	Cleanup 
	Wscript.quit
end if




Set View =	DataBase.OpenView("SELECT * FROM CustomAction" )
View.execute	
Set record = view.Fetch	

' Recursively list the entries within the Table
While Not (record Is Nothing)
	value=Record.StringData(4) 
	
	if instr(value,":\") >0 then
		TestResult="Warning"
		Message = Message &Root &Key &" " &Value &chr(10) &chr(13)
	End If

Set record = view.Fetch
Wend

If Message = "" Then
	ScriptResult = "Pass"
	Message = "No Hard Coded Entries"
Else
	ScriptResult = "Warning"
	Message = "The following entries exist:" &chr(10) &chr(13) &message 
End If









'****************************************
'Cleanup
'****************************************

Results
Cleanup

'****************************************
'Functions and Subs
'****************************************
sub Results
	outfile.writeline( "<my:Test>")
	outfile.writeline( "<my:Name>" &Name &"</my:Name>") 
	outfile.writeline( "<my:ScriptName>" &ScriptName &"</my:ScriptName>")
	outfile.writeline( "<my:ScriptResult>" &ScriptResult &"</my:ScriptResult>") 
	outfile.writeline( "<my:ScriptPurpose>" &ScriptPurpose &"</my:ScriptPurpose>")
	outfile.writeline("<my:HelpURL>http://www.laurierhodes.info/sites/default/files/MSICheck/" &ScriptName &".html</my:HelpURL>") 	
	outfile.writeline( "<my:Message>" &Message &"</my:Message>") 
	outfile.writeline( "<my:ResultComments></my:ResultComments>") 
	outfile.writeline( "</my:Test>")
	outfile.close
end sub

function DoesTableExist(strTableName)
	Set View =	DataBase.Openview("SELECT * FROM _Tables")
	view.execute	
	Set record = view.Fetch	
	
	tablefound=0
	While Not (record Is Nothing) and tablefound=0
		if Record.Stringdata(1) = strTableName then
			tablefound=1
		end if
		Set record = view.Fetch
	wend
	if tablefound=0 then
		DoesTableExist=False
	else
		DoesTableExist=True
	end if
end function

function MakeSafe(tempstring)
	tempstring = Replace (tempstring,">","&gt;") 
	tempstring = Replace (tempstring,"<","&lt;") 
	tempstring = Replace (tempstring,"&","&amp;") 
	tempstring = Replace (tempstring,"'","&apos;") 
	tempstring = Replace (tempstring,chr(34),"&quot;") 
	MakeSafe = tempstring
end function

sub Cleanup
	'Set Objects to Nothing 
	Set objShell =	Nothing
	Set wshNetwork 	= Nothing
	Set Installer 	= Nothing
	Set View 		= Nothing
	set Record 		= Nothing
End Sub
