'****************************************
'Declare variables
'****************************************
Dim strmsiFile, strTransformFile, Appdata, PackageName 
Const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002


'****************************************
' Set Objects
'****************************************

Set objShell      = CreateObject("WScript.Shell")
set objFSO        = CreateObject("scripting.FileSystemObject") 
Set Installer     =	CreateObject("WindowsInstaller.installer")

'****************************************
' Retrieve Test Package Settings
'****************************************
strMsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSiFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile") 
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\Currentversion\Explorer\Shell Folders\Local Appdata")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")
Website           = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\Website")

set outfile       =	objFSO.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for append
Set Database      =	Installer.OpenDatabase(strMsiFile, 0)


If Not strTransformFile ="" Then 
	Database.ApplyTransform strTransformFile, 0
End if


'****************************************
'Script
'****************************************
Name			    ="Complete File Removal" 'Friendly name of the script
ScriptPurpose	= "Ensure that all files are removed on uninstall so additionalremoval packages will not require development"
ScriptName		="19_SystemFolderAttributes" 'Actual name of the script run
ScriptResult	=""


Set View =	DataBase.OpenView("SELECT * FROM File")
View.execute
Set record = view.Fetch
count=0

While Not (record Is Nothing)
	count = count+1
	Set record = view.Fetch
wend

'We know hom many files are contained within our MergeModules 'We have to set the Size of our array
'we only need to test if there are actually files in the file table. 
if count = 0 then
message = "There are no files delivered as part of this MSI" 
	'msgbox "There are no files delivered as part of this MSI" 
	ScriptResult = "Pass"
	Results
	Cleanup
	Wscript.quit
end if

count=count-1

'we create an array for the members of the file table 
ReDim FileArray(count,3)
View.execute
Set record = view.Fetch '
count=0
'Let's Populate our Array	

For X=0 to Count 
	FileArray(count,1) =Record.StringData(1)	
	FileArray(Count,2) =Record.StringData(2)	
	FileArray(Count,3) =Record.StringData(3)	
	count = count+1	
	Set record = view.Fetch 
Next	
'we now have a populated array count=count-1	
'Now we want to look at the system attributes on teh Component table

Set View =	DataBase.Openview("SELECT * FROM Component")
view.execute
Set record = view.Fetch
Message=""

' Recursively list the entries within the Table
while Not (record Is Nothing)
	Filename=Record.StringData(3)
	filename=ucase(filename)
	if instr(filename,"SYSTEm")=1 then
		'If this is one of the system folders
		If Record.StringData(4) = "24" then
		'Files will never be removed
		'check to see if our problem component exists in the
			If ucase(FileArray(x,2)) = filename then
				'It does exist as a file and doesn't have attribute 24
				Message = Message &chr(13) &chr(10) &Record.StringData(1)	
			end if
		else
				'For x=0 to count
				'Next
		End If
	end if

Set record = view.Fetch
Wend


If Message = "" Then
	Message = "All components will be uninstalled"
	ScriptResult="Pass"
Else
	ScriptResult="Warning"
	Message = "Components in this package are set with attribute 24: " &chr(13) &chr(10) &Message 
End if






'****************************************
'Cleanup
'****************************************

Results
Cleanup

'****************************************
'Functions and Subs
'****************************************
sub Results
	outfile.writeline( "<my:Test>")
	outfile.writeline( "<my:Name>" &Name &"</my:Name>") 
	outfile.writeline( "<my:ScriptName>" &ScriptName &"</my:ScriptName>")
	outfile.writeline( "<my:ScriptResult>" &ScriptResult &"</my:ScriptResult>") 
	outfile.writeline( "<my:ScriptPurpose>" &ScriptPurpose &"</my:ScriptPurpose>")
	outfile.writeline("<my:HelpURL>http://www.laurierhodes.info/sites/default/files/MSICheck/" &ScriptName &".html</my:HelpURL>") 
	outfile.writeline( "<my:Message>" &Message &"</my:Message>") 
	outfile.writeline( "<my:ResultComments></my:ResultComments>") 
	outfile.writeline( "</my:Test>")
	outfile.close
end sub

function DoesTableExist(strTableName)
	Set View =	DataBase.Openview("SELECT * FROM _Tables")
	view.execute	
	Set record = view.Fetch	
	
	tablefound=0
	While Not (record Is Nothing) and tablefound=0
		if Record.Stringdata(1) = strTableName then
			tablefound=1
		end if
		Set record = view.Fetch
	wend
	if tablefound=0 then
		DoesTableExist=False
	else
		DoesTableExist=True
	end if
end function

function MakeSafe(tempstring)
	tempstring = Replace (tempstring,">","&gt;") 
	tempstring = Replace (tempstring,"<","&lt;") 
	tempstring = Replace (tempstring,"&","&amp;") 
	tempstring = Replace (tempstring,"'","&apos;") 
	tempstring = Replace (tempstring,chr(34),"&quot;") 
	MakeSafe = tempstring
end function

sub Cleanup
	'Set Objects to Nothing 
	Set objShell =	Nothing
	Set wshNetwork 	= Nothing
	Set Installer 	= Nothing
	Set View 		= Nothing
	set Record 		= Nothing
End Sub
