'****************************************
'Declare variables
'****************************************
Dim strmsiFile, strTransformFile, Appdata, PackageName 
Const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002


'****************************************
' Set Objects
'****************************************

Set objShell      = CreateObject("WScript.Shell")
set objFSO        = CreateObject("scripting.FileSystemObject") 
Set Installer     =	CreateObject("WindowsInstaller.installer")

'****************************************
' Retrieve Test Package Settings
'****************************************
strMsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSiFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile") 
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\Currentversion\Explorer\Shell Folders\Local Appdata")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")
Website           = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\Website")

set outfile       =	objFSO.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for append
Set Database      =	Installer.OpenDatabase(strMsiFile, 0)


If Not strTransformFile ="" Then 
	Database.ApplyTransform strTransformFile, 0
End if


'****************************************
'Script
'****************************************
Name			="" 'Friendly name of the script
ScriptPurpose	= "Ensure that the Rootdrive property is set"
ScriptName		="" 'Actual name of the script run
ScriptResult	=""

Name	="Critical Files keypathed" 'Friendly name of the script
ScriptPurpose	= "Ensure that critical Ocx, DLL and EXE files are all keypathed"
ScriptName	="49_DLLEXEOCXKeypath" 'Actual name of the script run




if DoesTableExist("File") = False then
	ScriptResult = "Pass"
	Message = "This package does not include any files"
	Results 
	Cleanup 
end if

'if the file table exists we need to determine all the files that are dlls, exes or ocxs
CriticalFi1ecount=0
Set View =	DataBase.OpenView("SELECT * FROM File")
View.execute
Set record = view. Fetch
While Not (record Is Nothing)
	if CheckCritical(Record.StringData(3)) = true then
	'We simply create an array of critical Files
	'First step is to count them
	CriticalFilecount=CriticalFilecount+1
end if
Set record = view.Fetch 
Wend

CriticalFilecount=CriticalFilecount-1
Redim CriticalFileArray(CriticalFilecount,3)

'Then we create an array
Set View =	DataBase.OpenView("SELECT * FROM File")
view.execute
CriticalFilecount=0
Set record = view.Fetch
While Not (record Is Nothing)
if CheckCritical(Record.StringData(3)) = true then 
	CriticalFileArray(CriticalFilecount,1) = Record.StringData(1) 'File 
	criticalFileArray(CriticalFilecount,2) = Record.StringData(2) 'Component 
	CriticalFileArray(CriticalFilecount,3) = Shortname(Record.StringData(3)) 'FileName
	CriticalFilecount=CriticalFilecount + 1
end if
Set record = view.Fetch
Wend

'then we use SQL to ensure critical files are keypaths
for x = 0 to ubound(CriticalFileArray)
	Set View =	DataBase.OpenView("SELECT KeyPath FROM Component WHERE KeyPath ='" &CriticalFileArray(x,1) &"'")
	view.execute
	Set record = view.Fetch
	if (record Is Nothing) then
		message = message &CriticalFileArray(x,3) &chr(13) &chr(10)
	end if
next

If Message = "" Then
	Message = "No Keypath Problems detected"
	ScriptResult="Pass"
Else
	ScriptResult="Fail"
	Message = "Critical files not keypathed: " &chr(13) &chr(10) &Message
End if





'****************************************
'Cleanup
'****************************************

Results
Cleanup

'****************************************
'Functions and Subs
'****************************************
function Shortname(Tempvar)
If instr(Tempvar,"|") then
	Tempvar=right(tempvar, len(tempvar) - instr(tempvar,"|"))
end if
shortname = Tempvar
end function

function CheckCritical(Tempvar)
	if right(Ucase(Tempvar),4)=".EXE" then 
		CheckCritical = True
	end if
	if right(Ucase(Tempvar),4)=".DLL" then 
		CheckCritical = True
	end if
	if right(Ucase(Tempvar),4)=".0CX" then 
		CheckCritical = True
	end if
end function

sub Results
	outfile.writeline( "<my:Test>")
	outfile.writeline( "<my:Name>" &Name &"</my:Name>") 
	outfile.writeline( "<my:ScriptName>" &ScriptName &"</my:ScriptName>")
	outfile.writeline( "<my:ScriptResult>" &ScriptResult &"</my:ScriptResult>") 
	outfile.writeline( "<my:ScriptPurpose>" &ScriptPurpose &"</my:ScriptPurpose>")
	outfile.writeline("<my:HelpURL>http://www.laurierhodes.info/sites/default/files/MSICheck/" &ScriptName &".html</my:HelpURL>") 
	outfile.writeline( "<my:Message>" &Message &"</my:Message>") 
	outfile.writeline( "<my:ResultComments></my:ResultComments>") 
	outfile.writeline( "</my:Test>")
	outfile.close
end sub

function DoesTableExist(strTableName)
	Set View =	DataBase.Openview("SELECT * FROM _Tables")
	view.execute	
	Set record = view.Fetch	
	
	tablefound=0
	While Not (record Is Nothing) and tablefound=0
		if Record.Stringdata(1) = strTableName then
			tablefound=1
		end if
		Set record = view.Fetch
	wend
	if tablefound=0 then
		DoesTableExist=False
	else
		DoesTableExist=True
	end if
end function

function MakeSafe(tempstring)
	tempstring = Replace (tempstring,">","&gt;") 
	tempstring = Replace (tempstring,"<","&lt;") 
	tempstring = Replace (tempstring,"&","&amp;") 
	tempstring = Replace (tempstring,"'","&apos;") 
	tempstring = Replace (tempstring,chr(34),"&quot;") 
	MakeSafe = tempstring
end function

sub Cleanup
	'Set Objects to Nothing 
	Set objShell =	Nothing
	Set wshNetwork 	= Nothing
	Set Installer 	= Nothing
	Set View 		= Nothing
	set Record 		= Nothing
End Sub
