'****************************************
'Declare variables
'****************************************
Dim strmsiFile, strTransformFile, Appdata, PackageName 
Const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002


'****************************************
' Set Objects
'****************************************

Set objShell      = CreateObject("WScript.Shell")
set objFSO        = CreateObject("scripting.FileSystemObject") 
Set Installer     =	CreateObject("WindowsInstaller.installer")

'****************************************
' Retrieve Test Package Settings
'****************************************
strMsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSiFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile") 
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\Currentversion\Explorer\Shell Folders\Local Appdata")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")
Website           = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\Website")

set outfile       =	objFSO.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for append
Set Database      =	Installer.OpenDatabase(strMsiFile, 0)


If Not strTransformFile ="" Then 
	Database.ApplyTransform strTransformFile, 0
End if

'****************************************
'Script
'****************************************
Name	          ="ICE validation" 'Friendly name of the script
ScriptPurpose	  = "Record formal ICE validation errors"
ScriptName	    ="61_ICEValidation" 'Actual name of the script run
ScriptResult	  =""

'Ice Errors cannot be retrieved without MSIva12 being installed 'The Microsoft utility always installs to the same location

'The only purpose of this script is to merge Transforms and Exit.


'Ice validation can only be run against an MSI. If a transform exists, it will need to be merged
'With the MSI before validations can occur.
'If Not strTransformFile ="" Then Database.ApplyTransform strTransformFile, 0
'We will have to create a temporary database and run checks against it 
If (objfso.FileExists(TempDir &"\MSICheckTemp.msi")) Then
    objfso.DeleteFile(TempDir &"\MSICheckTemp.msi") 
End If
If (objfso.FileExists(TempDir &"\MSICheckTemp.mst")) Then
    objfso.DeleteFile(TempDir &"\MSICheckTemp.mst")
End If

objfso.CopyFile strMsiFile , TempDir &"\MSICheckTemp.msi"

If strTransformFile ="" then
	'NO transforms - the check can be run against the original database 
else
    Set TempDatabase = Installer.OpenDatabase(TempDir &"\MSICheckTemp.msi", 1)
    TempDatabase.ApplyTransform strTransformFile, 0
    TempDatabase.Commit
end if

'Run the ICE validation checks
objFile =""
If objfso.FileExists("C:\Program Files\MsiVal2\msival2.exe") then
	msival2Path = "C:\Program Files\MsiVa12\msival2.exe" 
end if
If objfso.FileExists("C:\Program Files (x86)\MsiVal2\msival2.exe") then
	msival2Path = "C:\Program Files (x86)\MsiVal2\msival2.exe" 
end if

'msival2Path = objFile.ShortPath

IF msival2Path = "" then
	message = "Microsoft's Commandline validation tool is not installed. Checks could not be completed"
	Results
	Wscript.quit
end if







Cleanup

'****************************************
'Functions and Subs
'****************************************
sub Results
	outfile.writeline( "<my:Test>")
	outfile.writeline( "<my:Name>" &Name &"</my:Name>") 
	outfile.writeline( "<my:ScriptName>" &ScriptName &"</my:ScriptName>")
	outfile.writeline( "<my:ScriptResult>" &ScriptResult &"</my:ScriptResult>") 
	outfile.writeline( "<my:ScriptPurpose>" &ScriptPurpose &"</my:ScriptPurpose>")
	outfile.writeline("<my:HelpURL>http://www.laurierhodes.info/sites/default/files/MSICheck/" &ScriptName &".html</my:HelpURL>") 
	outfile.writeline( "<my:Message>" &Message &"</my:Message>") 
	outfile.writeline( "<my:ResultComments></my:ResultComments>") 
	outfile.writeline( "</my:Test>")
	outfile.close
end sub

function DoesTableExist(strTableName)
	Set View =	DataBase.Openview("SELECT * FROM _Tables")
	view.execute	
	Set record = view.Fetch	
	
	tablefound=0
	While Not (record Is Nothing) and tablefound=0
		if Record.Stringdata(1) = strTableName then
			tablefound=1
		end if
		Set record = view.Fetch
	wend
	if tablefound=0 then
		DoesTableExist=False
	else
		DoesTableExist=True
	end if
end function

function MakeSafe(tempstring)
	tempstring = Replace (tempstring,">","&gt;") 
	tempstring = Replace (tempstring,"<","&lt;") 
	tempstring = Replace (tempstring,"&","&amp;") 
	tempstring = Replace (tempstring,"'","&apos;") 
	tempstring = Replace (tempstring,chr(34),"&quot;") 
	MakeSafe = tempstring
end function

sub Cleanup
	'Set Objects to Nothing 
	Set objShell =	Nothing
	Set wshNetwork 	= Nothing
	Set Installer 	= Nothing
	Set View 		= Nothing
	set Record 		= Nothing
End Sub
