'****************************************
'Declare variables
'****************************************
Dim strmsiFile, strTransformFile, Appdata, PackageName 
Const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002


'****************************************
' Set Objects
'****************************************

Set objShell      = CreateObject("WScript.Shell")
set objFSO        = CreateObject("scripting.FileSystemObject") 
Set Installer     =	CreateObject("WindowsInstaller.installer")

'****************************************
' Retrieve Test Package Settings
'****************************************
strMsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSiFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile") 
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\Currentversion\Explorer\Shell Folders\Local Appdata")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")
Website           = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\Website")

set outfile       =	objFSO.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for append
Set Database      =	Installer.OpenDatabase(strMsiFile, 0)


If Not strTransformFile ="" Then 
	Database.ApplyTransform strTransformFile, 0
End if

'****************************************
'Script
'****************************************
Name	            = "ICE validation" 'Friendly name of the script
ScriptPurpose	    = "Record formal ICE validation errors"
ScriptName	      = "61_ICEValidation" 'Actual name of the script run
ScriptResult	    = ""

'Ice Errors cannot be retrieved without MSIva12 being installed 'The Microsoft utility always installs to the same location

'Run the ICE validation checks
objFile =""
If objfso.FileExists("C:\Program Files\MsiVal2\msival2.exe") then
	'msival2Path = "C:\Program Files\MsiVa12\msival2.exe" 
	Set objFile=objFSO.GetFile("C:\Program Files\MsiVa12\msival2.exe")
	msival2Path = objFile.ShortPath
end if
If objfso.FileExists("C:\Program Files (x86)\MsiVal2\msival2.exe") then
	'msival2Path = "C:\Program Files (x86)\MsiVal2\msival2.exe" 
	Set objFile=objFSO.GetFile("C:\Program Files (x86)\MsiVal2\msival2.exe")
	msival2Path = objFile.ShortPath
end if

'msival2Path = objFile.ShortPath

IF msival2Path = "" then
	message = "Microsoft's Commandline validation tool (MSIVal2) is not installed. Checks could not be completed"
	Results
	Wscript.quit
end if



Set objFile=objFSO.GetFile(objFSO.GetFile(wscript.ScriptFullName).ParentFolder & "\Resources\darice.cub")
DarIceShortPath = objFile.ShortPath
'If strTransformFile ="" then
' ErrorCode = objShell.Run ("cmd.exe /c " &msival2Path &" "&chr(34) &strMsiFile &chr(34) &" " &DarIceShortPath &" -f > " &chr(34) &TempDir &"\MSIVal.txt " &chr(34), 0, True) 'Hide the run window
'else
'msgbox "cmd.exe /c "&chr(34) &msival2Path &chr(34) &" "&chr(34) &TempDir &"\MSICheckTemp.msi" &chr(34) &" " &DarIceShortPath &" -f > " &chr(34) &TempDir &"\MSIVal.txt" &chr(34)
'ErrorCode = objShell.Run ("cmd.exe /k "&chr(34) &msival2Path &chr(34) &" "&chr(34) &TempDir &"\MSICheckTemp.msi" &chr(34) &" " &DarIceShortPath &" -f > " &chr(34) &TempDir &"\MSIVal.txt" &chr(34), , True) 'Hide the run window
ErrorCode = objShell.Run ("cmd.exe /c " & msival2Path  &" "&chr(34) &TempDir &"\MSICheckTemp.msi" &chr(34) &" " &DarIceShortPath &" -f > " &chr(34) &TempDir &"\MSIVal.txt" &chr(34), 0, True) 'Hide the run window

'end if
If objfso.FileExists(TempDir &"\MSIVal.txt") Then
'Open the output and read the contents into xml
 Set file = objfso.openTextFile(TempDir &"\MSIVal.txt", 1)
 Do while NOt file.AtEndofStream
  fileline= MakeSafe(file.readline) 
  message = message &fileline' &chr(13) &chr(10)
  Loop
	file.Close
end if
'Cleanup








'****************************************
'Cleanup
'****************************************

Results
Cleanup

'****************************************
'Functions and Subs
'****************************************
sub Results

	outfile.writeline( "<my:ICEErrors>")
	outfile.writeline( Message ) 
  outfile.writeline( "</my:ICEErrors>")

	outfile.writeline( "<my:ICEErrorJustification></my:ICEErrorJustification>")


end sub

function DoesTableExist(strTableName)
	Set View =	DataBase.Openview("SELECT * FROM _Tables")
	view.execute	
	Set record = view.Fetch	
	
	tablefound=0
	While Not (record Is Nothing) and tablefound=0
		if Record.Stringdata(1) = strTableName then
			tablefound=1
		end if
		Set record = view.Fetch
	wend
	if tablefound=0 then
		DoesTableExist=False
	else
		DoesTableExist=True
	end if
end function

function MakeSafe(tempstring)
	tempstring = Replace (tempstring,">","&gt;") 
	tempstring = Replace (tempstring,"<","&lt;") 
	tempstring = Replace (tempstring,"&","&amp;") 
	tempstring = Replace (tempstring,"'","&apos;") 
	tempstring = Replace (tempstring,chr(34),"&quot;") 
	MakeSafe = tempstring
end function

sub Cleanup
	'Set Objects to Nothing 
	Set objShell =	Nothing
	Set wshNetwork 	= Nothing
	Set Installer 	= Nothing
	Set View 		= Nothing
	set Record 		= Nothing
End Sub
